<template lang="pug">
  .list
    .preloader-items(
      v-if="isPreloading"
    )
      masonry(
        :cols="columnsQuantity"
        gutter="4"
        ref="preloaderMasonry"
        style="width: 100%"
      )
        .animated-background(
          v-for="itemStyles in preloadingItems"
          :style="itemStyles"
          :class="{'no-animation': isUploadsAndEmpty}"
        )
    .not-found(v-else-if="searchQuery && !getItems().length")
      div Hmm, seems we don't have thing you are looking for...
      a.button.black.big(href="http://request.icons8.com/photo-request" target="_blank") Request a photo
    .list-container
      .scroll-container(
        v-app-scroll
        ref="scrollContainer"
        :class="{ uploads: this.entity === 'uploads', opaque: !isPreloading }"
      )
        masonry(
          :cols="columnsQuantity"
          gutter="4"
          ref="masonry"
        )

          //- items all    

          .item(
            v-show="!checkFaces"
            v-for="item in getItems()"
            :key="item.id"
            @mouseenter="showDeleteButton($event)"
          )
            .position-container(
              :style="getItemStyle(item)"
              :class="{ model: item.type === TYPE_MODEL }"
              @click="itemOnclick(item)"
              @dragstart="handleDragStart(item, $event)"
              @dragend="handleDragEnd(item)"
              draggable="true"
            )
              .status-container(
                v-if="item.uploadingStatus"
                :class="{transparent: item.uploadingStatus === STATUS_SUCCESS, touch: item.uploadingStatus === STATUS_SUCCESS}"
              )
                .success(v-if="item.uploadingStatus === STATUS_SUCCESS" v-html="$icons.success")
                .error(v-if="item.uploadingStatus === STATUS_ERROR" v-html="$icons.error")
                .loader(v-if="item.uploadingStatus === STATUS_UPLOADING")
              .infoPanel
                .swapFace(
                  v-if="item.face && item.face.replaceable"
                  @mouseover="showFacePopup"
                  @mouseleave="hideFacePopup"
                ) face
                .ai(
                  v-if="item.croppedWithAI"
                  @mouseover="showAIpopup"
                  @mouseleave="hideAIpopup"
                ) AI
              img.item-image(:src="item.src || item.thumb")
            .delete-button(
              v-if="[TYPE_UPLOAD, TYPE_UPLOAD_BACKGROUND].includes(item.type)"
              v-html="$icons.close"
              @click.stop="remove(item)"
            )

          //- items with swapp face  

          .item(
            v-show="checkFaces"
            v-if="item.face && item.face.replaceable"
            v-for="item in getItems()"

            @mouseenter="showDeleteButton($event)"
          )
            .position-container(
              :style="getItemStyle(item)"
              :class="{ model: item.type === TYPE_MODEL }"
              @click="itemOnclick(item)"
              @dragstart="handleDragStart(item, $event)"
              @dragend="handleDragEnd(item)"
              draggable="true"
            )
              .status-container(
                v-if="item.uploadingStatus"
                :class="{transparent: item.uploadingStatus === STATUS_SUCCESS, touch: item.uploadingStatus === STATUS_SUCCESS}"
              )
                .success(v-if="item.uploadingStatus === STATUS_SUCCESS" v-html="$icons.success")
                .error(v-if="item.uploadingStatus === STATUS_ERROR" v-html="$icons.error")
                .loader(v-if="item.uploadingStatus === STATUS_UPLOADING")
              .infoPanel
                .swapFace(
                  v-if="item.face && item.face.replaceable"
                  @mouseover="showFacePopup"
                  @mouseleave="hideFacePopup"
                ) face
                .ai(
                  v-if="item.croppedWithAI"
                  @mouseover="showAIpopup"
                  @mouseleave="hideAIpopup"
                ) AI
              img.item-image(:src="item.src || item.thumb")
            .delete-button(
              v-if="[TYPE_UPLOAD, TYPE_UPLOAD_BACKGROUND].includes(item.type)"
              v-html="$icons.close"
              @click.stop="remove(item)"
            )

      .load-button(v-show="showLoadButton" v-on:click="startLoadingItems")
        .background
        .text Load more
      .loader-container(v-show="itemsLoading")
        .loader
      .drag-mirror
      .face-popup(v-show="showFace")
        .title This image has a swappable face
        .description We mask the images one by one manually. Using this image, you vote for faster manual processing.
      .ai-popup(v-show="showAI")
        .title This image was masked by AI
        .description You can swap the face of the model to any of the existing collection
</template>

<script>
import { mapState, mapActions } from 'vuex'
import storeService from '../../services/store'
import backgroundService from '../../services/items/background'
import modelService from '../../services/items/model'
import objectService from '../../services/items/object'
import itemsService from '../../services/items/common'
import photosApi from '../../api/photos'
import AddItemCommand from '../../history/commands/addItem'
import config from '../../config'
import dataService from '~/services/data'
const TYPE_MODEL = itemsService.TYPE_MODEL
const TYPE_UPLOAD = itemsService.TYPE_UPLOAD
const TYPE_UPLOAD_BACKGROUND = itemsService.TYPE_UPLOAD_BACKGROUND

export default {
  name: 'List',
  props: {
    entity: {
      required: true,
      type: String
    },
    isSearching: {
      default: false,
      type: Boolean
    },
    isSorting: {
      default: false,
      type: Boolean
    }
  },
  data () {
    return {
      loading: true,
      loadingMore: false,
      showLoadButton: false,
      itemsLoading: false,
      showAI: false,
      showFace: false,
      checkFaces: false,
      containerWidth: 0,
      preloadingItems: [],
      backgroundReplaceCommand: null,
      TYPE_MODEL,
      TYPE_UPLOAD,
      TYPE_UPLOAD_BACKGROUND,
      STATUS_UPLOADING: dataService.STATUS_UPLOADING,
      STATUS_SUCCESS: dataService.STATUS_SUCCESS,
      STATUS_ERROR: dataService.STATUS_ERROR
    }
  },
  computed: {
    ...mapState({
      objects: function (state) {
        return this.handleItemsChange('objects')
      },
      backgrounds: function (state) {
        return this.handleItemsChange('backgrounds')
      },
      models: function (state) {
        return this.handleItemsChange('models')
      },
      uploads: function (state) {
        return this.handleUploadsChange()
      },
      searchObjects: function () {
        return this.handleItemsChange('searchObjects')
      },
      searchBackgrounds: function () {
        return this.handleItemsChange('searchBackgrounds')
      },
      searchModels: function () {
        return this.handleItemsChange('searchModels')
      },
      columnsQuantity: function (state) {
        const columnsQuantity = this.getColumnsQuantity(this.containerWidth)

        if (this.$refs.masonry) {
          this.$refs.masonry.displayColumns = columnsQuantity
        }

        if (this.$refs.preloaderMasonry) {
          this.$refs.preloaderMasonry.displayColumns = columnsQuantity
        }

        return columnsQuantity
      },
      currentPages: state => state.editor.currentPages,
      leftSidebarWidth: state => state.editor.leftSidebarWidth,
      searchQuery: state => state.editor.searchQuery,
      isMobile: state => state.editor.isMobile
    }),
    isPreloading () {
      return (!this.searchQuery && this.loading) || this.isSearching || this.isSorting || this.isUploadsAndEmpty
    },
    sorting () {
      return this.$store.state.editor[this.entity].sorting
    },
    isUploadsAndEmpty () {
      return this.entity === 'uploads' && !this.uploads.items.length
    }
  },
  watch: {
    entity () {
      this.scrollToTop()
    },
    sorting () {
      this.scrollToTop()
    },
    leftSidebarWidth () {
      this.containerWidth = this.leftSidebarWidth
      this.$nextTick(() => this.checkHeight())
    },
    isMobile () {
      this.setContainerWidth()
    }
  },
  created () {
    const columnsQuantity = this.getColumnsQuantity(this.containerWidth)
    this.generatePreloaderItems(Math.floor(this.containerWidth / columnsQuantity))
    this.setContainerWidth()
  },
  mounted () {
    const scrollElement = this.$refs.scrollContainer.SimpleBar.getScrollElement()
    window.addEventListener('resize', this.handleWindowResize)
    scrollElement.addEventListener('scroll', this.scrollHandler)
  },
  destroyed () {
    window.removeEventListener('resize', this.handleWindowResize)
    document.removeEventListener('scroll', this.scrollHandler)
  },
  methods: {
    ...mapActions([
      'modelsRelatedToSet',
      'objectsRelatedToSet',
      'backgroundsRelatedToSet',
      'setBackgrounds',
      'setModels',
      'setObjects'
    ]),
    scrollToTop () {
      if (this.$refs.scrollContainer) {
        this.$refs.scrollContainer.SimpleBar.getScrollElement().scrollTop = 0
      }
    },
    remove (item) {
      this.$emit('delete')
      photosApi.deleteUserImage(item.id)
      this.$store.dispatch('setUploads', { total: this[this.entity].total - 1, items: this[this.entity].items.filter(listItem => listItem.id !== item.id) })
      this.$store.dispatch('deleteCurrentUpload', item.id)
    },
    showDeleteButton (event) {
      const $item = event.target
      const $deleteButton = $item.querySelector('.delete-button')
      if ($deleteButton) {
        const position = $item.getBoundingClientRect()
        $deleteButton.style.top = `${position.top - 182}px`
        $deleteButton.style.left = `${position.left + position.width - config.leftSidebar.actionsWidth - 18}px`
      }
    },
    getColumnsQuantity (containerWidth) {
      let columnsQuantity = 0

      let columnWidth = 100
      if (containerWidth > 400) {
        columnWidth = 120
      }
      columnsQuantity = Math.floor(containerWidth / columnWidth)

      return columnsQuantity
    },
    generatePreloaderItems (itemWidth) {
      for (let i = 0; i < 50; i++) {
        this.preloadingItems.push({
          'min-width': itemWidth - 6 + 'px',
          height: (Math.floor(Math.random() * 1000) + 650) / 10 + 'px'
        })
      }
    },
    handleItemsChange (entity) {
      const items = this.$store.state.editor[entity].items
      if (this.entity === entity) {
        if (items.length) {
          this.loading = false
          this.$nextTick(() => {
            this.checkHeight()
            this.fixMasonry()
          })
        }
      }
      return this.$store.state.editor[entity]
    },
    handleUploadsChange () {
      const uploads = { ...this.$store.state.editor.uploads, items: [...this.$store.state.editor.uploads.items, ...this.$store.state.editor.currentUploads] }
      if (uploads.items.length) {
        this.$nextTick(() => {
          this.checkHeight()
          this.fixMasonry()
        })
      }
      this.loading = false
      return uploads
    },
    checkHeight () {
      // Check if there is no scroll (few elements)
      if (
        this.$refs.masonry &&
        this[this.entity].items.length < this.$store.state.editor[this.entity].total &&
        this.$refs.masonry.$el.offsetHeight <= this.$refs.scrollContainer.querySelector('.simplebar-scroll-content').offsetHeight
      ) {
        this.showLoadButton = true
      }
    },
    getItemStyle (item) {
      const listWidth = this.containerWidth - 16
      const guttersWidth = this.columnsQuantity > 1 ? (this.columnsQuantity - 1) * 4 : 0
      let width = (listWidth - guttersWidth) / this.columnsQuantity
      let widthRatio = width / item.width
      let height = item.height * widthRatio

      // If picture is too tall
      if (height / width > config.itemMaxRatio) {
        height = width * config.itemMaxRatio
      }

      return { height: height + 'px' }
    },
    getItems () {
      if (!this[this.entity]) {
        debugger
      }
      return this[this.entity].items
    },
    startLoadingItems () {
      return new Promise(resolve => {
        const entities = [
          'models',
          'objects',
          'backgrounds',
          'uploads',
          'searchModels',
          'searchObjects',
          'searchBackgrounds'
        ]
        if (!this.loadingMore && entities.includes(this.entity)) {
          this.loadingMore = true
          this.showLoadButton = false
          this.itemsLoading = true
          this.$nextTick(() => {
            this.loadItems()
              .then(() => {
                this.$nextTick(() => {
                  this.checkHeight()
                  this.itemsLoading = false
                  this.loadingMore = false
                  resolve()
                })
              })
          })
        }
      })
    },
    setContainerWidth () {
      this.containerWidth = this.isMobile ? window.innerWidth - config.leftSidebar.actionsWidth : this.leftSidebarWidth
    },
    loadItemsByEntity (initEntity, loadItemsFunction, service, resolve, store = 'default') {
      const isSearch = store === 'search'
      const entity = isSearch ? `search${initEntity.charAt(0).toUpperCase() + initEntity.slice(1)}` : initEntity
      const upperFirstEntity = entity.charAt(0).toUpperCase() + entity.slice(1)
      const page = this.$store.state.editor[entity].page + 1
      let params = Object.assign({ page }, service.getSortingParams(this.$store.state.editor[entity].sorting))

      if (isSearch) {
        params.query = this.searchQuery
      }

      loadItemsFunction(params)
        .then(response => {
          const items = service.handlePhotos(response[initEntity], true, store)
          this.$store.dispatch(`set${upperFirstEntity}`, { items, total: response.total, page })
          resolve()
        })
    },
    fixMasonry () {
      if (this.$refs.masonry) {
        const columns = [...this.$refs.masonry.$el.children]

        // Calculate columns height
        let columnsHeights = []
        columns.forEach(($column, index) => {
          const columnElements = [...columns[index].children]
          columnElements.forEach($element => {
            if (!columnsHeights[index]) {
              columnsHeights[index] = 0
            }
            columnsHeights[index] += $element.offsetHeight + 4
          })
        })

        for (let i = 0; i < 5; i++) {
          columnsHeights.forEach((columnHeight, index) => {
            const currentColumnHeight = columnsHeights[index]
            const previousColumnHeight = columnsHeights[index - 1]
            const nextColumnHeight = columnsHeights[index + 1]
            let $lastElement
            if (nextColumnHeight && currentColumnHeight - nextColumnHeight > 200) {
              $lastElement = columns[index].lastChild
              columns[index + 1].appendChild($lastElement)
              columnsHeights[index] -= $lastElement.offsetHeight + 4
              columnsHeights[index + 1] += $lastElement.offsetHeight + 4
            }
            if (previousColumnHeight && currentColumnHeight - previousColumnHeight > 200) {
              $lastElement = columns[index].lastChild
              columns[index - 1].appendChild($lastElement)
              columnsHeights[index] -= $lastElement.offsetHeight + 4
              columnsHeights[index - 1] += $lastElement.offsetHeight + 4
            }
          })
        }
      }
    },
    loadItems () {
      return new Promise(resolve => {
        switch (this.entity) {
          case 'backgrounds':
            this.loadItemsByEntity('backgrounds', photosApi.backgrounds, backgroundService, resolve)
            break
          case 'models':
            this.loadItemsByEntity('models', photosApi.models, modelService, resolve)
            break
          case 'objects':
            this.loadItemsByEntity('objects', photosApi.objects, objectService, resolve)
            break
          case 'uploads':
            this.loadItemsByEntity('uploads', photosApi.uploads, backgroundService, resolve)
            break
          case 'searchBackgrounds':
            this.loadItemsByEntity('backgrounds', photosApi.backgrounds, backgroundService, resolve, 'search')
            break
          case 'searchModels':
            this.loadItemsByEntity('models', photosApi.models, modelService, resolve, 'search')
            break
          case 'searchObjects':
            this.loadItemsByEntity('objects', photosApi.objects, objectService, resolve, 'search')
            break
        }
      })
    },
    itemOnclick (itemData) {
      if (!this.isUploadReady(itemData)) {
        return
      }

      this.$emit('selected')
      storeService.get('commandManager').execute(new AddItemCommand(itemData, {}, true))
    },
    handleDragStart (object, event) {
      if (!this.isUploadReady(object)) return
      // Get mouse position offset ratio
      let width, height
      switch (object.type) {
        case itemsService.TYPE_UPLOAD:
        case itemsService.TYPE_OBJECT:
          ({ width, height } = objectService.calculatePositionAndSize(object))
          break
        case itemsService.TYPE_MODEL:
          ({ width, height } = modelService.calculatePositionAndSize(object))
          break
        case itemsService.TYPE_UPLOAD_BACKGROUND:
        case itemsService.TYPE_BACKGROUND:
          ({ width, height } = backgroundService.calculatePositionAndSize(object))
          const ratio = 300 / width
          width *= ratio
          height *= ratio
          break
      }
      object.placeHeight = height

      // Create mirror
      const $mirror = new Image()
      $mirror.src = object.src || object.thumb
      $mirror.width = width
      $mirror.height = height
      document.querySelector('.drag-mirror').innerHTML = ''
      document.querySelector('.drag-mirror').appendChild($mirror)

      event.dataTransfer.setData('text/plain', JSON.stringify(object))
      event.dataTransfer.setDragImage($mirror, width / 2, height / 2)
    },
    handleDragEnd (item) {
      if (!this.isUploadReady(item)) return
      document.querySelector('.drag-mirror').innerHTML = ''
    },
    scrollHandler () {
      const scrollElement = this.$refs.scrollContainer.SimpleBar.getScrollElement()
      if (scrollElement.scrollTop > this.$refs.masonry.$el.offsetHeight - this.$refs.scrollContainer.offsetHeight - 20) {
        // Check if all items are loaded
        if (this[this.entity].items.length < this[this.entity].total) {
          this.startLoadingItems()
        }
      }
    },
    filterSwappFoto(){
      this.checkFaces = !this.checkFaces
    },
    showFacePopup (event) {
      const position = event.target.getBoundingClientRect()
      const popup = document.getElementsByClassName('face-popup')[0]
      popup.style.left = `${position.left - 76}px`
      if (document.body.offsetHeight - position.top <= 120) {
        popup.style.top = `${position.top - 220}px`
      } else {
        popup.style.top = `${position.top - 88}px`
      }
      this.showFace = true
      localStorage.setItem('sawAI', true)
    },
    hideFacePopup (event) {
      this.showFace = false
    },
    showAIpopup (event) {
      const position = event.target.getBoundingClientRect()
      const popup = document.getElementsByClassName('ai-popup')[0]
      popup.style.left = `${position.left - 76}px`
      if (document.body.offsetHeight - position.top <= 120) {
        popup.style.top = `${position.top - 220}px`
      } else {
        popup.style.top = `${position.top - 88}px`
      }
      this.showAI = true
      localStorage.setItem('sawAI', true)
    },
    hideAIpopup (event) {
      this.showAI = false
    },
    handleWindowResize () {
      this.setContainerWidth()
    },
    isUploadReady (item) {
      return !item.uploadingStatus || item.uploadingStatus === dataService.STATUS_SUCCESS
    }
  }
}
</script>

<style lang="scss" scoped>
  @import '../../assets/css/mixins';
  @import '../../assets/css/effects';

  $sidebar-color: #3b3b3b;

  .list {
    height: 100%;
    padding: 0;

    .not-found {
      display: flex;
      flex-direction: column;
      align-items: center;
      text-align: center;
      padding: 48px 48px 0 48px;

      .button {
        width: 140px;
        margin-top: 16px;
      }
    }

    .preloader-items {
      .animated-background {
        margin: 4px 0;
        border-radius: 6px;
        &.no-animation {
          animation: none;
        }
      }
    }

    .loader-container {
      position: absolute;
      display: flex;
      justify-content: center;
      background-color: #000;
      bottom: 0;
      left: 0;
      width: 100%;
      opacity: 0.5;

      .loader {
        height: 56px;
        position: relative;
        @include loading(#fff, 4px, 32px);
      }
    }

    .list-container {
      position: relative;
      overflow: visible;
      padding: 0 4px;
      width: 100%;
      height: 100%;

      .scroll-container {
        position: initial;
        width: 100%;
        height: 100%;
        opacity: 0;

        &.uploads{
          height: calc(100% - 56px);
        }

        &.opaque {
          opacity: 1;
          transition: opacity 0.5s;
        }
      }

      .item {
        margin-bottom: 4px;
        background-color: #f8f4ed;
        border-radius: 6px;
        min-width: 50px;
        min-height: 50px;
        cursor: pointer;

        .position-container {
          position: relative;
        }

        &:hover {
          .delete-button {
            opacity: 1;
            visibility: visible;
            transition: opacity 0.3s;
          }
        }

        .delete-button {
          width: 22px;
          height: 22px;
          position: absolute;
          z-index: 10;
          padding: 7px;
          background-color: #FF3A3A;
          border-radius: 50%;
          opacity: 0;
          visibility: hidden;

          &:hover {
            background-color: #ff0000;
          }
        }

        .status-container {
          transition: background-color .5s ease-in-out;
          position: absolute;
          display: flex;
          justify-content: center;
          align-items: center;
          background-color: rgba(0,0,0,0.5);
          bottom: 0;
          left: 0;
          width: 100%;
          height: 100%;
          align-items: center;
          cursor: auto;

          &.touch {
            cursor: pointer;
          }
          &.transparent{
            background-color: rgba(0,0,0,0);
          }
          .loader {
            height: 40px;
            position: relative;
            @include loading(#fff, 4px, 32px);
          }
          .success, .error {
            height: 40px;
            width: 40px;
            border-radius: 9999px;
            display: flex;
            align-items: center;
            justify-content: center;

            & > :first-child {
              width: 15px;
            }
          }
          .success {
            background: #4AC144;
          }
          .error {
            background: #FF3A3A;
          }
        }

        .drag {
          height: 100%;
        }

        &-image {
          object-fit: contain;
          height: 100%;
          width: 100%;
          display: block;
          border-radius: 6px;
        }

        .infoPanel{
          position:absolute;
          display: flex;
          align-items: center;
          left: 4px;
          bottom: 4px;
        }

        .ai {
          border-radius: 100px;
          background: rgba(0, 0, 0, 0.4);
          box-shadow: 0px 1px 0px rgba(0, 0, 0, 0.15);
          padding: 2px 8px;
          line-height: 11px;
          font-size: 10px;
          color: white;
          display: flex;
          align-items: center;
          justify-content: center;
        }

        .swapFace {
          border-radius: 100px;
          background: #00A9F0;
          box-shadow: 0px 1px 0px rgba(0, 0, 0, 0.15);
          padding: 2px 8px;
          margin-right: 4px;
          font-size: 10px;
          line-height: 12px;
          text-transform: capitalize;
          color: white;
          display: flex;
          align-items: center;
          justify-content: center;
        }
      }

      .model {
        padding-top: 5px;
      }
    }

    .load-button {
      position: absolute;
      bottom: 0;
      left: 0;
      width: 100%;
      height: 35px;
      cursor: pointer;

      .background {
        opacity: 0.4;
        background-color: #000;
        width: 100%;
        height: 100%;
      }

      .text {
        width: 100%;
        height: 100%;
        position: absolute;
        top: 5px;
        text-align: center;
      }

      &:hover {
        .background {
          opacity: 0.5;
        }
      }
    }

    .drag-mirror {
      position: fixed;
      top: -10000px;
    }

    .face-popup {
      position: absolute;
      right: -270px;
      top: 30px;
      width: 306px;
      background: rgba(0, 0, 0, 0.9);
      border-radius: 8px;
      padding: 12px;
      font-size: 14px;
      line-height: 20px;

      .title {
        color: #00A9F0;
        padding-bottom: 3px;
      }
    }

    .ai-popup {
      position: absolute;
      right: -270px;
      top: 30px;
      width: 306px;
      background: rgba(0, 0, 0, 0.9);
      border-radius: 8px;
      padding: 12px;
      font-size: 14px;
      line-height: 20px;

      .title {
        color: #FFCD4D;
        padding-bottom: 3px;
      }
    }
  }
</style>
